/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.test;

import javax.ejb.Stateless;
import javax.transaction.*;
import java.sql.*;
import javax.naming.*;
import javax.annotation.*;


/**
 *
 * @author ctabin
 */
@Stateless
public class LocalProcessorBean implements LocalProcessorLocal {
    @Resource(name="jdbc/__default")
    javax.sql.DataSource ds;
    
    public String test1(String input)
    {
        try {
          System.err.println("+++ IN test1()");
            syncTest(); // Position 1 (OK)

            Connection con = ds.getConnection();
            con.close();

         } catch (Exception e) {
           e.printStackTrace();
         }
        
        return input;
    }
    
    public String test2(String input)
    {
        try {
          System.err.println("+++ IN test2()");

          Connection con = ds.getConnection();
          con.close();

          syncTest(); // Position 2 (Fails)
        } catch (Exception e) {
          e.printStackTrace();
        }
        return input;
    }
 
    private void syncTest() throws NamingException {
        InitialContext ctx = new InitialContext();
        TransactionSynchronizationRegistry registry =
    (TransactionSynchronizationRegistry)
    ctx.lookup("java:comp/TransactionSynchronizationRegistry");
        registry.registerInterposedSynchronization(new MySynchronization());
    }

    private class MySynchronization implements Synchronization {
          public void beforeCompletion() {
            System.err.println("+++ IN beforeCompletion()");
          }
    
          public void afterCompletion(int i) {
            System.err.println("+++ IN afterCompletion()");
          }
    }
}
